disableSerialization;

private ["_event", "_params", "_display"];
_event = _this select 0;
_params = _this select 1;


switch (_event) do
{
   case "onLoad":
   {
      _display = _params select 0;

      _display displayCtrl 700 ctrlSetTooltip "Object class for the missile";
      _display displayCtrl 700 ctrlSetText (missilefire select 1);

      _display displayCtrl 701 ctrlSetTooltip "X (relative to launcher's sides)";
      _display displayCtrl 701 ctrlSetText format["%1", ((missilefire select 2) select 0)];

      _display displayCtrl 702 ctrlSetTooltip "Y (relative to launcher's heading)";
      _display displayCtrl 702 ctrlSetText format["%1", ((missilefire select 2) select 1)];

      _display displayCtrl 703 ctrlSetTooltip "Z (relative to launcher's altitude)";
      _display displayCtrl 703 ctrlSetText format["%1", ((missilefire select 2) select 2)];

      _display displayCtrl 704 ctrlSetTooltip "Init heading (relative to launcher in this dialog)";
      _display displayCtrl 704 ctrlSetText format["%1", (missilefire select 3)];

      _display displayCtrl 705 ctrlSetTooltip "Initial elevation angle at launch time (90 = auto aim vertically)";
      _display displayCtrl 705 sliderSetRange [-90, 90];
      _display displayCtrl 705 sliderSetSpeed [1, 10];
      _display displayCtrl 705 sliderSetPosition (missilefire select 4);
      _display displayCtrl 706 ctrlSetText format["%1", missilefire select 4];

      _display displayCtrl 707 ctrlSetTooltip "Initial speed at launch time (launcher velocity is added to this)";
      _display displayCtrl 707 ctrlSetText format["%1", missilefire select 5];

      _display displayCtrl 708 ctrlSetTooltip "Maximum speed after initial acceleration (40 ~ 900)";
      _display displayCtrl 708 ctrlSetText format["%1", missilefire select 6];

      _display displayCtrl 709 ctrlSetTooltip "Acceleration in m/s^2";
      _display displayCtrl 709 sliderSetRange [10, 250];
      _display displayCtrl 709 sliderSetSpeed [1, 10];
      _display displayCtrl 709 sliderSetPosition (missilefire select 7);
      _display displayCtrl 742 ctrlSetText format["%1", missilefire select 7];


      _display displayCtrl 710 ctrlSetTooltip "Range to target to explode (to execute warhead script)";
      _display displayCtrl 710 ctrlSetText format["%1", missilefire select 9];

      _display displayCtrl 743 ctrlSetTooltip "Vertical delta in m relative to target's center where the missile will aim to";
      _display displayCtrl 743 ctrlSetText format["%1", missilefire select 31];

      _display displayCtrl 744 ctrlSetTooltip "If distance between missile and target plus this value is larger than distance between missile and flares, missile will go for flares. Use < 0 values to increase inmunity to flares";
      _display displayCtrl 744 ctrlSetText format["%1", missilefire select 32];


      _display displayCtrl 711 ctrlSetTooltip "Seeker range while in active mode (onboard missile seeker)";
      _display displayCtrl 711 ctrlSetText format["%1", missilefire select 10];

      _display displayCtrl 712 ctrlSetTooltip "Initial working mode at launch time";
      _display displayCtrl 712 lbAdd "0 - Inertial. Reach cruise alt, then switch to mode 1";
      _display displayCtrl 712 lbAdd "1 - Inertial. Reach interception point, then switch to mode 2";
      _display displayCtrl 712 lbAdd "2 - Active seeker.";
      _display displayCtrl 712 lbSetCurSel (missilefire select 11);

      _display displayCtrl 713 ctrlSetTooltip "Cruise altitude over target to reach before switching from mode 0 to mode 1";
      _display displayCtrl 713 ctrlSetText format["%1", missilefire select 12];

      _display displayCtrl 714 ctrlSetTooltip "Warhead script (empty for none), you will find more inside mando_missiles\warheads folder. Test your own scripts here";
      _display displayCtrl 714 ctrlSetText (missilefire select 13);

      _display displayCtrl 715 ctrlSetTooltip "Smoke trail script (empty for none), you will find more inside mando_missiles\exhausts folder. Test your own scripts here";
      _display displayCtrl 715 ctrlSetText (missilefire select 14);

      _display displayCtrl 716 ctrlSetTooltip "Sound resource for engine (empty for none)";
      _display displayCtrl 716 ctrlSetText (missilefire select 15);

      _display displayCtrl 717 ctrlSetTooltip "Engine sound duration (> 0 if any sound entered)";
      _display displayCtrl 717 ctrlSetText format["%1", missilefire select 16];

      _display displayCtrl 718 ctrlSetTooltip "Endurance, once elapsed missile's engine will stop";
      _display displayCtrl 718 ctrlSetText format["%1", missilefire select 17];

      _display displayCtrl 719 ctrlSetTooltip "Terrain avoidance (missile climbing over terrain elevations)";
      _display displayCtrl 719 lbAdd "No";
      _display displayCtrl 719 lbAdd "Yes";
      if (missilefire select 18) then
      {
         _display displayCtrl 719 lbSetCurSel 1; 
      }
      else
      {
         _display displayCtrl 719 lbSetCurSel 0; 
      };

      _display displayCtrl 720 ctrlSetTooltip "Delay between target position updates while flying in inertial mode 1";
      _display displayCtrl 720 ctrlSetText format["%1", missilefire select 19];

      _display displayCtrl 721 ctrlSetTooltip "Delay between spawning the missile and switching on its engine";
      _display displayCtrl 721 ctrlSetText format["%1", missilefire select 20];

      _display displayCtrl 722 ctrlSetTooltip "Delay between spawning the missile and start of any guidance";
      _display displayCtrl 722 ctrlSetText format["%1", missilefire select 21];

      _display displayCtrl 723 ctrlSetTooltip "If Yes, the missile will be detectable and interceptable";
      _display displayCtrl 723 lbAdd "No";
      _display displayCtrl 723 lbAdd "Yes";
      if (missilefire select 22) then
      {
         _display displayCtrl 723 lbSetCurSel 1; 
      }
      else
      {
         _display displayCtrl 723 lbSetCurSel 0; 
      };

      _display displayCtrl 724 ctrlSetTooltip "Launch script to add effects at launch time (empty if none), you will find more inside mando_missiles\launch folder. Test your own scripts here";
      _display displayCtrl 724 ctrlSetText (missilefire select 24);

      _display displayCtrl 725 ctrlSetTooltip "Horizontal agility in degrees per second (normal is 55)";
      _display displayCtrl 725 sliderSetRange [0, 120];
      _display displayCtrl 725 sliderSetSpeed [0.2, 1];
      _display displayCtrl 725 sliderSetPosition (missilefire select 25);
      _display displayCtrl 726 ctrlSetText format["%1", missilefire select 25];

      _display displayCtrl 727 ctrlSetTooltip "Vertical agility in degrees per second (normal is 35)";
      _display displayCtrl 727 sliderSetRange [0, 120];
      _display displayCtrl 727 sliderSetSpeed [0.2, 1];
      _display displayCtrl 727 sliderSetPosition (missilefire select 26);
      _display displayCtrl 728 ctrlSetText format["%1", missilefire select 26];

      _display displayCtrl 729 ctrlSetTooltip "Active guidance accuracy level (0 to 1)";
      _display displayCtrl 729 sliderSetRange [0, 1];
      _display displayCtrl 729 sliderSetSpeed [0.1, 0.1];
      _display displayCtrl 729 sliderSetPosition (missilefire select 27);
      _display displayCtrl 730 ctrlSetText format["%1", missilefire select 27];

      _display displayCtrl 731 ctrlSetTooltip "Intercept final aproach (Yes), collision final aproach (No)";
      _display displayCtrl 731 lbAdd "No";
      _display displayCtrl 731 lbAdd "Yes";
      if (missilefire select 28) then
      {
         _display displayCtrl 731 lbSetCurSel 1; 
      }
      else
      {
         _display displayCtrl 731 lbSetCurSel 0; 
      };

      _display displayCtrl 732 ctrlSetTooltip "Seeker frontal detection horizontal arc / 2";
      _display displayCtrl 732 sliderSetRange [10, 180];
      _display displayCtrl 732 sliderSetSpeed [1, 10];
      _display displayCtrl 732 sliderSetPosition (missilefire select 29);
      _display displayCtrl 733 ctrlSetText format["%1", missilefire select 29];

      _display displayCtrl 734 ctrlSetTooltip "Seeker frontal detection vertical arc / 2";
      _display displayCtrl 734 sliderSetRange [10, 180];
      _display displayCtrl 734 sliderSetSpeed [1, 10];
      _display displayCtrl 734 sliderSetPosition (missilefire select 30);
      _display displayCtrl 735 ctrlSetText format["%1", missilefire select 30];

      _display displayCtrl 736 ctrlSetTooltip "Missile params you may use in your scripts or for mando_missileattacker.sqf";
      _display displayCtrl 737 ctrlSetTooltip "Fires a missile and updates the parameter line";

      _display displayCtrl 738 ctrlSetTooltip "Some classes to be used as missiles";
      _display displayCtrl 738 lbAdd "<- Its current content";
      _display displayCtrl 738 lbAdd "M_Sidewinder_AA";
      _display displayCtrl 738 lbAdd "Bo_GBU12_LGB";
      _display displayCtrl 738 lbAdd "CruiseMissile2";
      _display displayCtrl 738 lbAdd "mu90";
      _display displayCtrl 738 lbAdd "M_Ch29_AT";
      _display displayCtrl 738 lbAdd "M_Vikhr_AT";
      _display displayCtrl 738 lbAdd "M_Hellfire_AT";
      _display displayCtrl 738 lbAdd "M_TOW_AT";
      _display displayCtrl 738 lbAdd "M_AT5_AT";
      _display displayCtrl 738 lbAdd "M_R73_AA";
      _display displayCtrl 738 lbAdd "M_Strela_AA";
      _display displayCtrl 738 lbAdd "M_Stinger_AA";
      _display displayCtrl 738 lbAdd "M_Javelin_AT";
      _display displayCtrl 738 lbAdd "R_M136_AT";
      _display displayCtrl 738 lbAdd "R_PG7VR_AT";
      _display displayCtrl 738 lbAdd "AV8B";
      _display displayCtrl 738 lbAdd "Su34";
      _display displayCtrl 738 lbsetCurSel 0;


      _display displayCtrl 739 ctrlSetTooltip "Type of target";
      _display displayCtrl 739 lbAdd "against air target";
      _display displayCtrl 739 lbAdd "against ground target";
      _display displayCtrl 739 lbAdd "against sea target";
      _display displayCtrl 739 lbAdd "against town target";
      _display displayCtrl 739 lbsetCurSel typeoftarget;


      _display displayCtrl 740 ctrlSetTooltip "Fire from";
      _display displayCtrl 740 lbAdd "ground launcher";
      _display displayCtrl 740 lbAdd "air launcher";
      _display displayCtrl 740 lbAdd "sea launcher";
      _display displayCtrl 740 lbsetCurSel typeoflauncher;

      for [{_i = 700},{_i < 745},{_i = _i + 1}] do
      {
         _display displayCtrl _i ctrlSetTooltipColorBox [0.2, 0.2, 0, 1];
         _display displayCtrl _i ctrlSetTooltipColorText [0, 0, 0, 1];
         _display displayCtrl _i ctrlSetTooltipColorShade [1, 1, 0, 1];
      };


      _display displayCtrl 800 ctrlSetTooltip "Horizontal range between camera and missile";
      _display displayCtrl 800 sliderSetRange [0, 100];
      _display displayCtrl 800 sliderSetSpeed [1, 10];
      _display displayCtrl 800 sliderSetPosition mando_camera_x;
      _display displayCtrl 801 ctrlSetText format["%1", mando_camera_x];

      _display displayCtrl 802 ctrlSetTooltip "Vertical range between camera and missile";
      _display displayCtrl 802 sliderSetRange [-100, 100];
      _display displayCtrl 802 sliderSetSpeed [1, 10];
      _display displayCtrl 802 sliderSetPosition mando_camera_y;
      _display displayCtrl 803 ctrlSetText format["%1", mando_camera_y];

      _display displayCtrl 804 ctrlSetTooltip "Angle between camera and missile";
      _display displayCtrl 804 sliderSetRange [0, 359];
      _display displayCtrl 804 sliderSetSpeed [1, 10];
      _display displayCtrl 804 sliderSetPosition mando_camera_ang;
      _display displayCtrl 805 ctrlSetText format["%1", mando_camera_ang];

      _display displayCtrl 806 ctrlSetTooltip "Air targets spawn alt (Applies to next spawned one)";
      _display displayCtrl 806 sliderSetRange [30, 4000];
      _display displayCtrl 806 sliderSetSpeed [1, 10];
      _display displayCtrl 806 sliderSetPosition mando_airtargets_alt;
      _display displayCtrl 807 ctrlSetText format["%1", mando_airtargets_alt];




      _display displayCtrl 808 ctrlSetTooltip "Air target type will be spawned once current one is destroyed";
      _display displayCtrl 808 ctrlSetText "A10";
      _display displayCtrl 809 ctrlSetTooltip "Some types of air targets";
      _display displayCtrl 809 lbAdd "A10";
      _display displayCtrl 809 lbAdd "AV8B";
      _display displayCtrl 809 lbAdd "C130J";
      _display displayCtrl 809 lbAdd "F35B";
      _display displayCtrl 809 lbAdd "Su34";
      _display displayCtrl 809 lbAdd "Su39";
      _display displayCtrl 809 lbAdd "Ka52";
      _display displayCtrl 809 lbAdd "CruiseMissile2";
      _display displayCtrl 809 lbsetCurSel 0;

      _display displayCtrl 810 ctrlSetTooltip "Sea target type will be spawned once current one is destroyed";
      _display displayCtrl 810 ctrlSetText "RHIB";
      _display displayCtrl 811 ctrlSetTooltip "Some types of sea targets";
      _display displayCtrl 811 lbAdd "RHIB";
      _display displayCtrl 811 lbAdd "Land_Destroyer";
      _display displayCtrl 811 lbsetCurSel 0;

      _display displayCtrl 812 ctrlSetTooltip "Land target type will be spawned once current one is destroyed";
      _display displayCtrl 812 ctrlSetText "T72_RU";
      _display displayCtrl 813 ctrlSetTooltip "Some types of land targets";
      _display displayCtrl 813 lbAdd "T72_RU";
      _display displayCtrl 813 lbAdd "M1A1";
      _display displayCtrl 813 lbAdd "MLRS";
      _display displayCtrl 813 lbAdd "AAV";
      _display displayCtrl 813 lbAdd "BMP3";
      _display displayCtrl 813 lbAdd "BTR90";
      _display displayCtrl 813 lbAdd "ZSU_CDF";
      _display displayCtrl 813 lbAdd "T90";
      _display displayCtrl 813 lbsetCurSel 0;


      _display displayCtrl 814 ctrlSetTooltip "Aproximate range with engine on based on speeds, acceleration and endurance";



      _display displayCtrl 1880 htmlLoad "mml_help.html";
      _display displayCtrl 1880 ctrlShow false;
   };

   case "onSliderElevation":
   {

      (findDisplay 23300) displayCtrl 706 ctrlSetText format["%1", sliderPosition ((findDisplay 23300) displayCtrl 705)];
   };

   case "onSliderHAgility":
   {

      (findDisplay 23300) displayCtrl 726 ctrlSetText format["%1", sliderPosition ((findDisplay 23300) displayCtrl 725)];
   };

   case "onSliderVAgility":
   {

      (findDisplay 23300) displayCtrl 728 ctrlSetText format["%1", sliderPosition ((findDisplay 23300) displayCtrl 727)];
   };

   case "onSliderAccuracy":
   {

      (findDisplay 23300) displayCtrl 730 ctrlSetText format["%1", sliderPosition ((findDisplay 23300) displayCtrl 729)];
   };

   case "onSliderHScan":
   {

      (findDisplay 23300) displayCtrl 733 ctrlSetText format["%1", sliderPosition ((findDisplay 23300) displayCtrl 732)];
   };

   case "onSliderVScan":
   {

      (findDisplay 23300) displayCtrl 735 ctrlSetText format["%1", sliderPosition ((findDisplay 23300) displayCtrl 734)];
   };

   case "onSlideraccel":
   {

      (findDisplay 23300) displayCtrl 742 ctrlSetText format["%1", sliderPosition ((findDisplay 23300) displayCtrl 709)];
   };

   case "onSliderCamRgx":
   {

      (findDisplay 23300) displayCtrl 801 ctrlSetText format["%1", sliderPosition ((findDisplay 23300) displayCtrl 800)];
      mando_camera_x = sliderPosition ((findDisplay 23300) displayCtrl 800);
   };

   case "onSliderCamRgy":
   {

      (findDisplay 23300) displayCtrl 803 ctrlSetText format["%1", sliderPosition ((findDisplay 23300) displayCtrl 802)];
      mando_camera_y = sliderPosition ((findDisplay 23300) displayCtrl 802);
   };

   case "onSliderCamAng":
   {

      (findDisplay 23300) displayCtrl 805 ctrlSetText format["%1", sliderPosition ((findDisplay 23300) displayCtrl 804)];
      mando_camera_ang = sliderPosition ((findDisplay 23300) displayCtrl 804);
   };

   case "onSliderAirAlt":
   {

      (findDisplay 23300) displayCtrl 807 ctrlSetText format["%1", sliderPosition ((findDisplay 23300) displayCtrl 806)];
      mando_airtargets_alt = sliderPosition ((findDisplay 23300) displayCtrl 806);
   };

   case "onComboAirType":
   {
      (findDisplay 23300) displayCtrl 808 ctrlSetText (((_this select 1) select 0) lbText ((_this select 1) select 1));
      target_type_air = ((_this select 1) select 0) lbText ((_this select 1) select 1);
   };

   case "onComboSeaType":
   {
      (findDisplay 23300) displayCtrl 810 ctrlSetText (((_this select 1) select 0) lbText ((_this select 1) select 1));
      target_type_sea = ((_this select 1) select 0) lbText ((_this select 1) select 1);
   };

   case "onComboLandType":
   {
      (findDisplay 23300) displayCtrl 812 ctrlSetText (((_this select 1) select 0) lbText ((_this select 1) select 1));
      target_type_land = ((_this select 1) select 0) lbText ((_this select 1) select 1);
   };


   case "onUpdateLine":
   {
      _index = lbCursel ((findDisplay 23300) displayCtrl 738);
      if (_index > 0) then
      {
         _text = (findDisplay 23300) displayCtrl 738 lbText _index;
         (findDisplay 23300) displayCtrl 700 ctrlSetText _text;
      };

      typeoftarget = lbCursel ((findDisplay 23300) displayCtrl 739);
      if (typeoftarget == 0) then
      {
         target = bomber1;
      }
      else
      {
         if (typeoftarget == 1) then 
         {
            target = tank1;
         }
         else
         {
            if (typeoftarget == 2) then 
            {
               target = boat1;
            }
            else
            {
               target = nearestBuilding landtarget;
            };
         };
      };

      typeoflauncher = lbCursel ((findDisplay 23300) displayCtrl 740);
      if (typeoflauncher == 0) then
      {
         launcher = launcher_land;
      }
      else
      {
         if (typeoflauncher == 1) then 
         {
            launcher = launcher_air;
         }
         else
         {
            launcher = launcher_sea;
         };
      };


      _line = format["[_launcher,""%1"",[%2,%3,%4],(getDir _launcher) + %5,%6,%7,%8,%9,_target,%10,%11,%12,%13,""%14"",""%15"",""%16"",%17,%18", 
                 ctrlText ((findDisplay 23300) displayCtrl 700), 
                 ctrlText ((findDisplay 23300) displayCtrl 701),
                 ctrlText ((findDisplay 23300) displayCtrl 702),
                 ctrlText ((findDisplay 23300) displayCtrl 703),
                 ctrlText ((findDisplay 23300) displayCtrl 704),
                 ctrlText ((findDisplay 23300) displayCtrl 706),
                 ctrlText ((findDisplay 23300) displayCtrl 707),
                 ctrlText ((findDisplay 23300) displayCtrl 708),
                 ctrlText ((findDisplay 23300) displayCtrl 742),
                 ctrlText ((findDisplay 23300) displayCtrl 710),
                 ctrlText ((findDisplay 23300) displayCtrl 711),
                 lbCurSel ((findDisplay 23300) displayCtrl 712),
                 ctrlText ((findDisplay 23300) displayCtrl 713),
                 ctrlText ((findDisplay 23300) displayCtrl 714),
                 ctrlText ((findDisplay 23300) displayCtrl 715),
                 ctrlText ((findDisplay 23300) displayCtrl 716),
                 ctrlText ((findDisplay 23300) displayCtrl 717),
                 ctrlText ((findDisplay 23300) displayCtrl 718)];
      if (lbCurSel ((findDisplay 23300) displayCtrl 719) == 0) then
      {
         _line = _line + ",false,";
      }
      else
      {
         _line = _line + ",true,";
      };
      _line = _line + format["%1,%2,%3",
                 ctrlText ((findDisplay 23300) displayCtrl 720),
                 ctrlText ((findDisplay 23300) displayCtrl 721),
                 ctrlText ((findDisplay 23300) displayCtrl 722)];

      if (lbCurSel ((findDisplay 23300) displayCtrl 723) == 0) then
      {
         _line = _line + ",false,";
      }
      else
      {
         _line = _line + ",true,";
      };
      _line = _line + format["_debug,""%1"",%2,%3,%4",
                 ctrlText ((findDisplay 23300) displayCtrl 724),
                 ctrlText ((findDisplay 23300) displayCtrl 726),
                 ctrlText ((findDisplay 23300) displayCtrl 728),
                 ctrlText ((findDisplay 23300) displayCtrl 730)];

      if (lbCurSel ((findDisplay 23300) displayCtrl 731) == 0) then
      {
         _line = _line + ",false,";
      }
      else
      {
         _line = _line + ",true,";
      };
      _line = _line + format["%1,%2,%3,%4]",
                 ctrlText ((findDisplay 23300) displayCtrl 733),
                 ctrlText ((findDisplay 23300) displayCtrl 735),
                 ctrlText ((findDisplay 23300) displayCtrl 743),
                 ctrlText ((findDisplay 23300) displayCtrl 744)];

       
      (findDisplay 23300) displayCtrl 736 ctrlSetText _line;
      _launcher=launcher;
      _target=target;
      _debug = true;
      call compile format["missilefire=%1",ctrlText ((findDisplay 23300) displayCtrl 736)];
      _launchparams = [];
      _launchparams = _launchparams + missilefire;
      _launchparams execVM "mando_missiles\mando_missile.sqf";
      missilefire set [3,parseNumber (ctrlText ((findDisplay 23300) displayCtrl 704))];

      target_type_air = ctrlText ((findDisplay 23300) displayCtrl 808);
      target_type_sea = ctrlText ((findDisplay 23300) displayCtrl 810);
      target_type_land = ctrlText ((findDisplay 23300) displayCtrl 812);

      _maxthrustedrange = 1/2*(parseNumber(ctrlText ((findDisplay 23300) displayCtrl 708))^2)/parseNumber(ctrlText ((findDisplay 23300) displayCtrl 742));

      _maxthrustedrange = _maxthrustedrange + parseNumber(ctrlText ((findDisplay 23300) displayCtrl 707))*parseNumber(ctrlText ((findDisplay 23300) displayCtrl 708))/parseNumber(ctrlText ((findDisplay 23300) displayCtrl 742));

      _maxthrustedrange = _maxthrustedrange + parseNumber(ctrlText ((findDisplay 23300) displayCtrl 708))*(parseNumber(ctrlText ((findDisplay 23300) displayCtrl 718))-parseNumber(ctrlText ((findDisplay 23300) displayCtrl 708))/parseNumber(ctrlText ((findDisplay 23300) displayCtrl 742)));

      (findDisplay 23300) displayCtrl 814 ctrlSetText format["Aproximate maximum thrusted range (m): %1",_maxthrustedrange];
   };


   case "onKeyDown":
   {
      if (((_this select 1) select 1) == 59) then
      {
// F1
         if (ctrlVisible 1880) then
         {
            ((findDisplay 23300) displayCtrl 1880) ctrlShow false;
         }
         else
         {
            ((findDisplay 23300) displayCtrl 1880) ctrlShow true;
         };

      };
   };   
   default {};
};

if (_event == "onKeyDown") then
{
   false
}
else
{
   true
};
